/*
 *	himo.c
 *
 *	uǂ
 *	Copyright (C) 2002 Naoyuki Sawa
 *
 *	* Mon Oct 21 06:00:00 JST 2002 Naoyuki Sawa
 *	- 쐬JnB
 */
#include "app.h"

/****************************************************************************
 *	qZ
 ****************************************************************************/

/*  */
static int
dot(POINT a, POINT b)
{
	return a.x * b.x + a.y * b.y;
}

/* O */
static int
cross(POINT a, POINT b)
{
	return a.x * b.y - a.y * b.x;
}

/*  */
static int
mag(POINT a)
{
	return sqrt_32(dot(a, a));
}

/* (p0-p1)(p0-p2)ɈړƂAŏɈ钸_T܂B */
static int /* 1AȂ0 */
find_himo(
	POINT p0,		/* Œ蒸_W */
	POINT p1,		/* ړO_W */
	POINT p2,		/* ړ㒴_W */
	const KUI* kui,		/* NCz */
	int n_kui,		/* NC̐ */
	int onl01,		/* p0->p1̃NC܂߂邩H */
	HIMO* himo)		/* _i[ */
{
	POINT p3;
	POINT v01 = { p1.x - p0.x, p1.y - p0.y };
	POINT v12 = { p2.x - p1.x, p2.y - p1.y };
	POINT v20 = { p0.x - p2.x, p0.y - p2.y };
	POINT v03, v13, v23;
	int o, i, n03, d13, i_cand, d13_cand, n03_cand;
	int x_min, y_min, x_max, y_max;

	/* _ԋ0ȂA܂B */
	if(v01.x == 0 && v01.y == 0) return 0;
	if(v12.x == 0 && v12.y == 0) return 0;
	if(v20.x == 0 && v20.y == 0) return 0;

	/* q̈ړ𒲂ׂ܂B(1:E/0:)
	 * qEɓAEB
	 * qɓAƂȂ܂B
	 */
	o = cross(v01, v12) >= 0;

	/* \̂NC͈̔͂𒲂ׂ܂B */
	                 x_min =                        x_max = p0.x;
	                 y_min =                        y_max = p0.y;
	if(p1.x < x_min) x_min = p1.x; if(p1.x > x_max) x_max = p1.x;
	if(p1.y < y_min) y_min = p1.y; if(p1.y > y_max) y_max = p1.y;
	if(p2.x < x_min) x_min = p2.x; if(p2.x > x_max) x_max = p2.x;
	if(p2.y < y_min) y_min = p2.y; if(p2.y > y_max) y_max = p2.y;

	/* ԍŏɈNCT܂B
	 * ԍŏɈNCƂ́A(Œ蒸_->ړO_)0xƂāA(Œ蒸_->NC)̊pxԏNĈƂłB
	 * pxȂAŒ蒸_牓̃NC̗p܂B
	 */
	i_cand = -1;
	d13_cand = -1; /* x} */
	n03_cand = -1; /* x} */
	for(i = 0; i < n_kui; i++) {
		p3 = kui[i];
		if(p3.x < x_min || x_max < p3.x ||
		   p3.y < y_min || y_max < p3.y) continue; /* 炩ɔ͈͊O             */
		if(p3.x == p0.x && p3.y == p0.y) continue; /* p0gɈ̂h */
		/* NC(p3) Œ蒸_(p0)-ړO_(p1)-ړ㒸_(p2) ̎Op`̒ɂ܂B */
		v03.x = p3.x - p0.x; v03.y = p3.y - p0.y;
		v13.x = p3.x - p1.x; v13.y = p3.y - p1.y;
		v23.x = p3.x - p2.x; v23.y = p3.y - p2.y;
		if(o ? ((onl01 ? cross(v01, v13) >= 0 : cross(v01, v13) > 0) && cross(v12, v23) >= 0 && cross(v20, v03) >= 0)
		     : ((onl01 ? cross(v01, v13) <= 0 : cross(v01, v13) < 0) && cross(v12, v23) <= 0 && cross(v20, v03) <= 0)) {
			/* (Œ蒸_->ړO_)0xƂāA(Œ蒸_->NC)̊pxr邽߂́Acosl߂܂B
			 * cosl傫قǊpxAȂ킿ɈNCłƔf܂B
			 */
			n03 = mag(v03);
			if(n03 == 0) continue;
			//d13 = (dot(v01, v03) << 8/*Œ菬ŔrB*/) / (n01 * n03);
			//cosl߂鎮͖{͂łAn01(p0->p1̒)͐EŒlȂ̂ŁA炸ɔrĂłB
			//炱܂B
			d13 = (dot(v01, v03) << 8/*Œ菬ŔrB*/) / n03;
			if(i_cand == -1 || /* A܂ */
			   d13 > d13_cand || /* pxA܂ */
			   (d13 == d13_cand && n03 > n03_cand)) { /* pxł艓΁A̗p */
				i_cand = i;
				d13_cand = d13;
				n03_cand = n03;
			}
		}
	}
	if(i_cand == -1) return 0; /* NC܂łB */

	/* NC̍Wƈi[܂B */
	himo->p = kui[i_cand];
	himo->o = o;

	return 1;
}

/* Oꂽ_菜AOꂽƂɂĕʂ̃NCɈzɉ܂B */
static int /* q̒_ */
unhimo(
	HIMO* himo,		/* _z */
	int n_himo,		/* _z̗vf */
	int max_himo,		/* _z̃LpVeB */
	POINT* kuis,		/* NCz */
	int n_kuis,		/* NC̐ */
	int side)		/* q̂ǂ瑤̒_`FbN邩H(0:himo[1]/1:himo[n_himo-2]) */
{
	POINT p0, p1, p2;
	POINT v01, v12;
	HIMO htmp;

	/* O_ȏȂ΁A܂B */
	if(n_himo < 3) return n_himo;

	/* 擪܂͖̎O_擾AxNgvZ܂B */
	if(side) {
		p0 = himo[n_himo - 3].p;
		p1 = himo[n_himo - 2].p;
		p2 = himo[n_himo - 1].p;
	} else {
		p0 = himo[2].p;
		p1 = himo[1].p;
		p2 = himo[0].p;
	}
	v01.x = p1.x - p0.x; v01.y = p1.y - p0.y;
	v12.x = p2.x - p1.x; v12.y = p2.y - p1.y;

	/* ̋tɂȂAO܂B */
	if(side ? (himo[n_himo - 2].o ? !(cross(v01, v12) >= 0) : !(cross(v01, v12) <= 0))
		: (himo[         1].o ? !(cross(v01, v12) <= 0) : !(cross(v01, v12) >= 0))) {
		/* Oꂽ_̕l߂܂B */
		if(side) {
			himo[n_himo - 2] = himo[n_himo - 1];
		} else {
			memmove(&himo[1], &himo[2], sizeof(HIMO) * (n_himo - 2));
		}
		n_himo--;
		/* _OꂽƂɂĕʂ̃NCɂЂH */
		while(n_himo < max_himo) {
			if(!find_himo(p0, p1, p2, kuis, n_kuis, 0, &htmp)) break;
			n_himo++;
			if(side) {
				himo[n_himo - 1] = himo[n_himo - 2];
				himo[n_himo - 1] = htmp;
			} else {
				htmp.o = !htmp.o;
				memmove(&himo[2], &himo[1], sizeof(HIMO) * (n_himo - 2));
				himo[1] = htmp;
			}
			p0 = htmp.p;
		}
	}

	return n_himo;
}

/* 擪܂͖̒_ړA_zɉ܂B */
int /* q̒_ */
move_himo(
	HIMO* himo,		/* _z */
	int n_himo,		/* _z̗vf */
	int max_himo,		/* _z̃LpVeB */
	POINT* kui,		/* NCz */
	int n_kui,		/* NC̐ */
	int side,		/* q̂ǂ瑤̒_ړ邩H(0:himo[0]/1:himo[n_himo-1]) */
	POINT p2)		/* ړ̒_W */
{
	POINT p0, p1;
	HIMO htmp;

	if(side) { /* ړ */
		p0 = himo[n_himo - 2].p; /* Œ蒸_W */
		p1 = himo[n_himo - 1].p; /* ړO_W */
	} else { /* 擪ړ */
		p0 = himo[1].p; /* Œ蒸_W */
		p1 = himo[0].p; /* ړO_W */
	}
	while(n_himo < max_himo) {
		if(!find_himo(p0, p1, p2, kui, n_kui, 1, &htmp)) break;
		/* A_Wǉ܂B */
		if(side) { /* ړ */
			himo[n_himo - 1] = htmp;
		} else { /* 擱ړ */
			htmp.o = !htmp.o;
			himo[0] = htmp;
			memmove(&himo[1], &himo[0], sizeof(HIMO) * n_himo);
		}
		n_himo++;
		p0 = htmp.p;
	}
	if(side) { /* ړ */
		himo[n_himo - 1].p = p2; /* ړ㒸_W */
	} else { /* 擪ړ */
		himo[0].p = p2; /* ړ㒸_W */
	}

	/* 擪or̒_̊O`FbNB */
	n_himo = unhimo(himo, n_himo, max_himo, kui, n_kui, side);

	return n_himo;
}
