/*
 *	main.c
 *
 *	uǂ
 *	Copyright (C) 2002 Naoyuki Sawa
 *
 *	* Mon Oct 21 06:00:00 JST 2002 Naoyuki Sawa
 *	- 쐬JnB
 */
#include "app.h"

//#define USE_MUSIC /* yCugꍇ́ÃV{`Ă */
#ifdef USE_MUSIC
#include "instdef.c"
#define music_play(data) do { music_stop(); PlayMusic((unsigned char*)(data)); } while(0)
#define music_stop() do { StopMusic(); sound_stop(music_wch); } while(0)
#else /*USE_MUSIC*/
#define music_play(data) ((void)0)
#define music_stop() ((void)0)
#endif /*USE_MUSIC*/

int
pceAppNotify(int type, int param)
{
	switch(type) {
	case APPNF_SMSTART:
		/* STARTɂVXej[}܂B
		 * ̃AvP[V̒ł́AVXej[\@͂܂B
		 */
		return APPNR_REJECT;
	case APPNF_EXITREQ:
		/* START+SELECTɂI}܂B
		 * ȊO̕@(pceAppReqExit()ĂяoAPC̏Iv(USBCOM#4))ɂI͉\łB
		 */
		if((pcePadGetDirect() & (PAD_START | PAD_SELECT)) == (PAD_START | PAD_SELECT)) return APPNR_REJECT;
		break;
	}
	return APPNR_IGNORE;
}

/* a`b̗Ԃ}N(b܂݂܂) */
#define RND(a, b) ((a) + rand() % ((b) - (a) + 1))

/****************************************************************************
 *	萔E^
 ****************************************************************************/

#define FPS		20			/* t[[g */
#define SEC(s)		((int)(FPS * (s)))	/* b->t[ϊ */

#define MAX_KUI		64		/* NC̍ő吔 */
#define MAX_HIMO	16		/* q̒_̍ő吔 */

#define MAX_MUSH	(4 * 4)		/* }V̍ő吔({5C~4łA炵܂) */
#define MAX_HOBB	4		/* zu̍ő吔 */
#define MAX_SHEAR	1		/* VFA[̍ő吔 */

/* ʏ̍WETCY */
#define HOME_X		 40		/* zủ */
#define HOME_Y		  1
#define HOME_W		 48
#define HOME_H		 13
#define FIELD_X		  3		/* tB[h */
#define FIELD_Y		 15
#define FIELD_W		122
#define FIELD_H		 70

/* }V/zu/VFA[ʂ̍\ */
typedef struct _ENEMY {
	int stat;			/* (0:) */
	int x, y;			/* ʒu(24.8bit) */
	int dir;			/* ړ(0:/1:E/2:E/3:E/4:/5:/6:/7:) */
	int cnt;			/* ėpJE^ */
	int anm;			/* Aj[VJE^ */
} ENEMY;
/* }V's stat */
#define STAT_MUSH_MOVE		1	/* ړ(cnt=ړԃJEgAbv) */
/* zu's stat */
#define STAT_HOBB_MOVE		1	/* ړ (cnt=ړԃJEgAbv) */
#define STAT_HOBB_CHASE_PRE	2	/* ړO (ԊǗ͑Ŝōs܂) */
#define STAT_HOBB_CHASE		3	/* ǐ (ԊǗ͑Ŝōs܂) */
#define STAT_HOBB_RETIRE	4	/* ޏ */
#define STAT_HOBB_WAIT		5	/* ҋ@ (cnt=ҋ@ԃJEgAbv) */
#define STAT_HOBB_APPEAR	6	/*  */
/* VFA['s stat */
#define STAT_SHEAR_MOVE_PRE	1	/* ړO(cnt=ړOԃJEgAbv) */
#define STAT_SHEAR_MOVE		2	/* ړ */
/* ړPʑx */
const v_dir[8][2] = { {0,-1},{1,-1},{1,0},{1,1},{0,1},{-1,1},{-1,0},{-1,-1} };

/* NC̃p^[B */
#define KUI_COLS	8		/* NC̕({菭Ȃł) */
#define KUI_ROWS	4
const unsigned char kui_ptn[][KUI_ROWS][KUI_COLS] = {{
	{1,1,1,1,1,1,1,1},
	{1,1,1,1,1,1,1,1},
	{1,1,1,1,1,1,1,1},
	{1,1,1,1,1,1,1,1},
},{
	{1,0,1,0,1,0,1,0},
	{0,1,0,1,0,1,0,1},
	{1,0,1,0,1,0,1,0},
	{0,1,0,1,0,1,0,1},
},{
	{0,0,1,1,1,1,0,0},
	{0,1,0,0,0,0,1,0},
	{0,1,0,0,0,0,1,0},
	{0,0,1,1,1,1,0,0},
}};

/* V[Y` */
typedef struct _SEASON {
	int kui_ptn_no;
	int mush_move_spd;
	int mush_move_cnt;
	int hobb_move_spd;
	int hobb_move_cnt;
	int hobb_chase_spd;
	int hobb_chase_cnt;
	int hobb_chase_itv;
	int hobb_chase_pre;
	int hobb_wait_cnt;
	int shear_gen_itv;
	int shear_move_pre;
	int shear_move_spd;
} SEASON;
const SEASON seasons[] = {
	{ 0 }, /* #0͎g܂ */
	{ 0, 0x30, SEC(0.5), 0x60, SEC(0.5), 0x80, SEC(2.0), SEC(15), SEC(1.5), SEC(5), SEC(10), SEC(1.5), 0xc0 },
	{ 0, 0x30, SEC(0.5), 0x60, SEC(0.5), 0x80, SEC(2.0), SEC(15), SEC(1.5), SEC(5), SEC(10), SEC(1.5), 0xc0 },
	{ 1, 0x34, SEC(0.5), 0x64, SEC(0.5), 0x84, SEC(2.5), SEC(14), SEC(1.5), SEC(5), SEC( 9), SEC(1.5), 0xc4 },
	{ 0, 0x34, SEC(0.5), 0x64, SEC(0.5), 0x84, SEC(2.5), SEC(14), SEC(1.5), SEC(5), SEC( 9), SEC(1.5), 0xc4 },
	{ 2, 0x38, SEC(0.5), 0x68, SEC(0.5), 0x88, SEC(3.0), SEC(13), SEC(1.5), SEC(5), SEC( 8), SEC(1.5), 0xc8 },
	{ 0, 0x38, SEC(0.5), 0x68, SEC(0.5), 0x88, SEC(3.0), SEC(13), SEC(1.5), SEC(5), SEC( 8), SEC(1.5), 0xc8 },
	{ 1, 0x3c, SEC(0.5), 0x6c, SEC(0.5), 0x8c, SEC(3.5), SEC(12), SEC(1.5), SEC(4), SEC( 7), SEC(1.5), 0xcc },
	{ 0, 0x3c, SEC(0.5), 0x6c, SEC(0.5), 0x8c, SEC(3.5), SEC(12), SEC(1.5), SEC(4), SEC( 7), SEC(1.5), 0xcc },
	{ 2, 0x40, SEC(0.5), 0x70, SEC(0.5), 0x90, SEC(4.0), SEC(11), SEC(1.0), SEC(4), SEC( 6), SEC(1.0), 0xd0 },
	{ 0, 0x40, SEC(0.5), 0x70, SEC(0.5), 0x90, SEC(4.0), SEC(11), SEC(1.0), SEC(4), SEC( 6), SEC(1.0), 0xd0 },
	{ 1, 0x44, SEC(0.5), 0x74, SEC(0.5), 0x94, SEC(4.5), SEC(10), SEC(1.0), SEC(4), SEC( 5), SEC(1.0), 0xd4 },
	{ 0, 0x44, SEC(0.5), 0x74, SEC(0.5), 0x94, SEC(4.5), SEC(10), SEC(1.0), SEC(4), SEC( 5), SEC(1.0), 0xd4 },
	{ 2, 0x48, SEC(0.5), 0x78, SEC(0.5), 0x98, SEC(5.0), SEC( 9), SEC(1.0), SEC(3), SEC( 4), SEC(1.0), 0xd8 },
	{ 0, 0x48, SEC(0.5), 0x78, SEC(0.5), 0x98, SEC(5.0), SEC( 9), SEC(1.0), SEC(3), SEC( 4), SEC(1.0), 0xd8 },
	{ 1, 0x4c, SEC(0.5), 0x7c, SEC(0.5), 0x9c, SEC(5.5), SEC( 8), SEC(1.0), SEC(3), SEC( 3), SEC(1.0), 0xdc },
	{ 0, 0x4c, SEC(0.5), 0x7c, SEC(0.5), 0x9c, SEC(5.5), SEC( 8), SEC(1.0), SEC(3), SEC( 3), SEC(1.0), 0xdc },
	{ 2, 0x50, SEC(0.5), 0x80, SEC(0.5), 0xa0, SEC(6.0), SEC( 7), SEC(0.5), SEC(3), SEC( 2), SEC(0.5), 0xe0 },
	{ 0, 0x50, SEC(0.5), 0x80, SEC(0.5), 0xa0, SEC(6.0), SEC( 7), SEC(0.5), SEC(3), SEC( 2), SEC(0.5), 0xe0 },
	{ 1, 0x60, SEC(0.5), 0xc0, SEC(0.5), 0xff, SEC(9.9), SEC( 5), SEC(0.5), SEC(1), SEC( 1), SEC(0.5), 0xff },
	{ 0, 0x60, SEC(0.5), 0xc0, SEC(0.5), 0xff, SEC(9.9), SEC( 5), SEC(0.5), SEC(1), SEC( 1), SEC(0.5), 0xff },
};
#define MAX_SEASON_NO	(sizeof seasons / sizeof *seasons - 1)
#define KUI_PTN_NO	(gi->season->kui_ptn_no)	/* NC̃p^[ԍ */
#define MUSH_MOVE_SPD	(gi->season->mush_move_spd)	/* }V̈ړx */
#define MUSH_MOVE_CNT	(gi->season->mush_move_cnt)	/* }V̈ړ */
#define HOBB_MOVE_SPD	(gi->season->hobb_move_spd)	/* züړx */
#define HOBB_MOVE_CNT	(gi->season->hobb_move_cnt)	/* züړ */
#define HOBB_CHASE_SPD	(gi->season->hobb_chase_spd)	/* zu̒ǐՑx */
#define HOBB_CHASE_CNT	(gi->season->hobb_chase_cnt)	/* zu̒ǐՎ */
#define HOBB_CHASE_ITV	(gi->season->hobb_chase_itv)	/* zu̒ǐՊԊu */
#define HOBB_CHASE_PRE	(gi->season->hobb_chase_pre)	/* zu̒ǐ՗\ */
#define HOBB_WAIT_CNT	(gi->season->hobb_wait_cnt)	/* zȗҋ@ */
#define SHEAR_GEN_ITV	(gi->season->shear_gen_itv)	/* VFA[̏oԊu */
#define SHEAR_MOVE_PRE	(gi->season->shear_move_pre)	/* VFA[̈ړO */
#define SHEAR_MOVE_SPD	(gi->season->shear_move_spd)	/* VFA[̈ړx */

/* Q[ */
typedef struct _GAMEINFO {
	int left;			/* c@(݂̋@̂܂) */
	int score;			/* XRA */
	int season_no;			/* V[Yԍ */
	const SEASON* season;		/* ݂̃V[Yւ̃|C^ */

	int miss;			/* ~XH */
	int cnt;			/* ėpJE^ */

	int hobb_stat;			/* 0:ǐՃC^[o/1:ǐՑO/2:ǐՒ */
	int hobb_cnt;			/* zupJE^ */

	int shear_cnt;			/* VFA[oC^[o(VFA[zɋ󂫂JEgAbv) */

	int n_kui;			/* NC̐ */
	KUI kui[MAX_KUI];		/* NC */
	int n_himo;			/* q̒_̐ */
	HIMO himo[MAX_HIMO];		/* q̒_(擪̓uA̓uł) */
	ENEMY mush[MAX_MUSH];		/* }V */
	ENEMY hobb[MAX_HOBB];		/* zu */
	ENEMY shear[MAX_SHEAR];		/* VFA[ */

	unsigned char fill[DISP_X * DISP_Y];	/* h(0x00:Ȃ/0x01`0x03:hς/0x8?:h蒆) */
} GAMEINFO;

/* _ */
#define MUSH_PTS	 10
#define HOBB_PTS	100
#define SHEAR_PTS	500

/* Lp^[B
 * 16x16sNZԊuŁA傫15x15sNZAS(7,7)łB
 * p^[ԍ̉ẼRǵAp^[łB
 */
#define CHR_TREE	0x00
#define CHR_KUI		0x10
#define CHR_LIBB	0x20	/* 3 */
#define CHR_RABB	0x30	/* 3 */
#define CHR_MUSH	0x40	/* 2 */
#define CHR_HOBB	0x50	/* 2x2 */
#define CHR_SHEAR	0x60	/* 2x3 */

/****************************************************************************
 *	ϐ
 ****************************************************************************/

unsigned char vbuff[DISP_X * DISP_Y];	/* zVRAM */
SURFACE surface;			/* zVRAM̃T[tFCX */
RENDER _render;				/* zVRAMւ̕` */
#define render (&_render)

int now;				/* O[o^C} */
int joy;				/* pbh */

extern const unsigned char PAT[];
PIECE_BMP pat, bg;

int hiscore;
GAMEINFO _gi;
#define gi (&_gi)

/****************************************************************************
 *	֐錾
 ****************************************************************************/

void app_init();
void app_exit();
void schedule();
void chr_disp(int x, int y, int pat, int param);
int demo();
void game();
void season_init();
void field_disp();
void enemy_work();

/****************************************************************************
 *	main
 ****************************************************************************/

int
main()
{
	/* B */
	app_init();

	/* C[vB */
	for(;;) {
		if(demo() != 0) break;
		game();
	}

	return 0;
}

/****************************************************************************
 *	app_init
 ****************************************************************************/

void
app_init()
{
	/* ʓIȏB */
	pceLCDDispStop();
	pceLCDSetBuffer(vbuff);
	pceAppSetProcPeriod(1000 / FPS);
	pcePadSetTrigMode(PP_MODE_SINGLE);
	pceLCDDispStart();

	/* `B */
	surface.w = DISP_X;
	surface.h = DISP_Y;
	surface.vbuff = vbuff;
	render_init(render, &surface, 0, 0, 0, 0, 0, 0, 0);

#ifdef USE_MUSIC
	/* yCu܂B */
	InitMusic();
#endif /*USE_MUSIC*/

	/* N[Abv֐o^B */
	atexit(app_exit);

	/* OtBbNB */
	texture_init(&pat, PAT);
	texture_init(&bg , PAT);
	bg.header.mask = 0;
	bg.mask = NULL;
}

/****************************************************************************
 *	app_exit
 ****************************************************************************/

void
app_exit()
{
#ifdef USE_MUSIC
	/* mɉyt~܂B
	 * TEh̒~̓CupceAppExit()ōsĂ̂ŁA
	 * ł͕Kv܂B
	 */
	StopMusic();
#endif /*USE_MUSIC*/
}

/****************************************************************************
 *	schedule
 ****************************************************************************/

void
schedule()
{
#define PAUSE_FONT	0x80		/* PAUSEtHg         */
#define PAUSE_STR	"PAUSE"		/* PAUSEbZ[W       */
#define PAUSE_W		(5 * 5)		/* PAUSEbZ[W̉ */
#define PAUSE_H		10		/* PAUSEbZ[W̏c */
#define PAUSE_X		((DISP_X - PAUSE_W) / 2) /* \ʒu */
#define PAUSE_Y		((DISP_Y - PAUSE_H) / 2) /* \ʒu */

	int pause, x, y;
	unsigned char save[PAUSE_H][PAUSE_W];

	pause = 0;
	for(;;) {
		pceLCDTrans();		/* ʍXV */
		yield();		/* VXe */
		joy = pcePadGet();	/* pbhԍXV */

		/* PAUSEB */
		///if(joy & TRG_START) {
		if(0) { /* ̃Q[͑S{^ĝPAUSE͂܂ */
			pause ^= 1;	/* PAUSEԐ؂ւ */
			if(pause & 1) {	/* PAUSE IN */
				/* PAUSEbZ[W\̃C[WޔB */
				for(y = 0; y < PAUSE_H; y++) {
					for(x = 0; x < PAUSE_W; x++) {
						save[y][x] = vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)];
					}
				}
			} else {	/* PAUSE OUT */
				/* PAUSEbZ[W\̃C[W𕜋AB */
				for(y = 0; y < PAUSE_H; y++) {
					for(x = 0; x < PAUSE_W; x++) {
						vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)] = save[y][x];
					}
				}
			}
		}
		if(!(pause & 1)) break;

		/* PAUSEbZ[W_ŕ\B */
		pceFontSetType(PAUSE_FONT);
		pceFontSetTxColor(pause & 2 ? 2 : 3);
		pceFontSetBkColor(pause & 2 ? 0 : 1);
		pceFontSetPos(PAUSE_X, PAUSE_Y);
		pceFontPutStr(PAUSE_STR);
		pause ^= 2;
	}
	now++;	/* O[o^C}XV */

#undef PAUSE_FONT
#undef PAUSE_STR
#undef PAUSE_W
#undef PAUSE_H
#undef PAUSE_X
#undef PAUSE_Y
}

/****************************************************************************
 *	chr_disp
 ****************************************************************************/

void
chr_disp(int x, int y, int chr, int param)
{
	draw_object(&pat,
		x - 7,
		y - 7,
		(chr      & 15) * 16,
		(chr >> 4 & 15) * 16,
		15,
		15,
		param);
}

/****************************************************************************
 *	demo
 ****************************************************************************/

int
demo()
{
	int x, y;
	unsigned char* p;

	for(;;) {
		schedule();

		/* X^[gHIH */
		if(joy & TRG_SELECT) return -1;
		if(joy & TRG_A     ) return 0;

		/* wi\B */
		draw_object(&bg, 0, 0, 0, 128, DISP_X, DISP_Y, DRW_NOMAL);
		p = &vbuff[DISP_X * FIELD_Y + FIELD_X];
		for(y = 0; y < FIELD_H; y++) {
			for(x = 0; x < FIELD_W; x++) {
				*p = (x ^ y) & 1 ? 1 : 2;
				p++;
			}
			p += DISP_X - FIELD_W;
		}

		/* ^Cg\B */
		pceFontSetType(0x81);
		pceFontSetTxColor(3);
		pceFontSetBkColor(-1);
		for(y = -1; y <= 1; y++) {
			for(x = -1; x <= 1; x++) {
				if(x == 0 && y == 0) continue;
				pceFontSetPos(x + (DISP_X - 8 * 6) / 2 - 4, y + 30);
				pceFontPutStr("Libble");
				pceFontSetPos(x + (DISP_X - 8 * 6) / 2 + 4, y + 45);
				pceFontPutStr("M");
				pceFontSetPos(x + (DISP_X - 8 * 6) / 2 + 4 + 8, y + 45 - 4);
				pceFontPutStr("odoki");
			}
		}
		pceFontSetTxColor(1);
		pceFontSetBkColor(-1);
		x = 0;
		y = 0;
		pceFontSetPos(x + (DISP_X - 8 * 6) / 2 - 4, y + 30);
		pceFontPutStr("Libble");
		pceFontSetPos(x + (DISP_X - 8 * 6) / 2 + 4, y + 45);
		pceFontPutStr("M");
		pceFontSetPos(x + (DISP_X - 8 * 6) / 2 + 4 + 8, y + 45 - 4);
		pceFontPutStr("odoki");

		/* XRA\B */
		pceFontSetType(0x82);
		pceFontSetTxColor(3);
		pceFontSetBkColor(-1);
		pceFontSetPos(0, 0);
		pceFontPutStr("1PSCORE");
		pceFontSetPos(0, 6);
		pceFontPrintf("%7d", gi->score < 9999999 ? gi->score : 9999999);
		pceFontSetPos(DISP_X - 4 * 7 + 1, 0);
		pceFontPutStr("HISCORE");
		pceFontSetPos(DISP_X - 4 * 7 + 1, 6);
		pceFontPrintf("%7d", hiscore < 9999999 ? hiscore : 9999999);

		/* vvg\B */
		if(now % SEC(1.0) < SEC(0.67)) {
			pceFontSetType(0x82);
			pceFontSetTxColor(3);
			pceFontSetBkColor(-1);
			pceFontSetPos((DISP_X - 4 * 10) / 2, DISP_Y - 4 * 5);
			pceFontPutStr(" A  START");
			pceFontSetPos((DISP_X - 4 * 10) / 2, DISP_Y - 4 * 3);
			pceFontPutStr("SEL EXIT");
		}
	}

	return 0; /* _~[ */
}

/****************************************************************************
 *	game
 ****************************************************************************/

/* point_in_polygon_32͍ӏ̓_|SOƌȂĂ܂̂ŁA
 * eӏ̓_|SƔ肷֐pӂ܂B
 * ̕AȂᑬȂ̂ŁACLiPCuւ̗̍p͌łB
 */
static int
point_in_polygon_ex(int px, int py, int points[/*n_points*/][2], int n_points)
{
	int i, x, y, x1, y1, x2, y2;

	/* ӏȊO͂Ŕł܂B */
	if(point_in_polygon_32(px, py, points, n_points)) return 1;

	/* ӏ̔B */
	for(i = 0; i < n_points; i++) {
		x1 = points[i][0];
		y1 = points[i][1];
		x2 = points[(i + 1) % n_points][0];
		y2 = points[(i + 1) % n_points][1];
		if(ortho_point_32(px, py, x1, y1, x2, y2, &x, &y) && x == px && y == py) return 1;
	}

	return 0;
}

/* ؏o */
#define TREE_COLS	8
#define TREE_ROWS	4
static const unsigned char tree_order[TREE_ROWS][TREE_COLS] = {
	{  0, 1, 2, 3, 4, 5, 6, 7 },
	{ 19,20,21,22,23,24,25, 8 },
	{ 18,31,30,29,28,27,26, 9 },
	{ 17,16,15,14,13,12,11,10 },
};
#define MAX_TREE_ORDER (sizeof tree_order / sizeof(unsigned char) - 1)

void
game()
{
	static int n_basisi, basisi[MAX_HIMO][2]; /* X^bNӂh~̂static */
	unsigned char c;
	int i, j, k, x, y, x_min, y_min, x_max, y_max, col, row;
	POINT p1, p2, p3, p4;
	ENEMY* enemy;

	/* Q[B */
	memset(gi, 0, sizeof(GAMEINFO));
	gi->left = 3;
	gi->season_no = 1; /* V[Y1(0͎g܂) */

	for(;;) {
		/* ؂鉉oB */
		for(i = 0; i <= MAX_TREE_ORDER; i++) {
			field_disp();
			y = FIELD_Y + 7 + (FIELD_H - TREE_ROWS * 16) / 2;
			for(row = 0; row < TREE_ROWS; row++)  {
				x = FIELD_X + 7 + (FIELD_W - TREE_COLS * 15) / 2;
				for(col = 0; col < TREE_COLS; col++) {
					if(i >= tree_order[row][col]) {
						chr_disp(x, y, CHR_TREE, DRW_NOMAL);
					}
					x += 15;
				}
				y += 16;
			}
			schedule();
		}

		/* V[YB */
		season_init();

		/* ؂čsoB */
		for(i = 0; i <= MAX_TREE_ORDER; i++) {
			field_disp();
			y = FIELD_Y + 7 + (FIELD_H - TREE_ROWS * 16) / 2;
			for(row = 0; row < TREE_ROWS; row++)  {
				x = FIELD_X + 7 + (FIELD_W - TREE_COLS * 15) / 2;
				for(col = 0; col < TREE_COLS; col++) {
					if(i <= tree_order[row][col]) {
						chr_disp(x, y, CHR_TREE, DRW_NOMAL);
					}
					x += 15;
				}
				y += 16;
			}
			schedule();
		}

		for(;;) {
			schedule();

			/********** uu **********/

			/* uړB */
			p1 = gi->himo[0].p;
			if((joy & PAD_LF) && (p1.x > FIELD_X)) p1.x--;
			if((joy & PAD_UP) && (p1.y > FIELD_Y)) p1.y--;
			if((joy & PAD_RI) && (p1.x < FIELD_X + FIELD_W - 1)) p1.x++;
			if((joy & PAD_DN) && (p1.y < FIELD_Y + FIELD_H - 1)) p1.y++;
			gi->n_himo = move_himo(gi->himo, gi->n_himo, MAX_HIMO, gi->kui, gi->n_kui, 0, p1);

			/* uړB */
			p1 = gi->himo[gi->n_himo - 1].p;
			if((joy & PAD_SELECT) && (p1.x > FIELD_X)) p1.x--;
			if((joy & PAD_START ) && (p1.y > FIELD_Y)) p1.y--;
			if((joy & PAD_A     ) && (p1.x < FIELD_X + FIELD_W - 1)) p1.x++;
			if((joy & PAD_B     ) && (p1.y < FIELD_Y + FIELD_H - 1)) p1.y++;
			gi->n_himo = move_himo(gi->himo, gi->n_himo, MAX_HIMO, gi->kui, gi->n_kui, 1, p1);

			/* ̌̃oVV`FbNŁAoVVȂn_basisi0ȊOɂȂ܂B */
			n_basisi = 0;

			/* qɂoVVH */
			for(i = 0; i < gi->n_himo - 1; i++) {
				p1 = gi->himo[i    ].p;
				p2 = gi->himo[i + 1].p;
				for(j = i + 2; j < gi->n_himo - 1; j++) {
					p3 = gi->himo[j    ].p;
					p4 = gi->himo[j + 1].p;
					if(cross_point_32(p1.x, p1.y, p2.x, p2.y, p3.x, p3.y, p4.x, p4.y, &x, &y)) {
						basisi[n_basisi][0] = x;
						basisi[n_basisi][1] = y;
						n_basisi++;
						for(k = i + 1; k <= j; k++) {
							basisi[n_basisi][0] = gi->himo[k].p.x;
							basisi[n_basisi][1] = gi->himo[k].p.y;
							n_basisi++;
						}
						goto BASISI;
					}
				}
			}

			/* tB[h̕ӂgoVVH */
			if(gi->n_himo >= 3) {
				p1 = gi->himo[0             ].p;
				p2 = gi->himo[gi->n_himo - 1].p;
				if((p1.x == p2.x && (p1.x == FIELD_X || p1.x == FIELD_X + FIELD_W - 1)) ||
				   (p1.y == p2.y && (p1.y == FIELD_Y || p1.y == FIELD_Y + FIELD_H - 1))) {
					for(i = 0; i < gi->n_himo; i++) {
						basisi[n_basisi][0] = gi->himo[i].p.x;
						basisi[n_basisi][1] = gi->himo[i].p.y;
						n_basisi++;
					}
					goto BASISI;
				}
			}

BASISI:			/* oVVB */
			if(n_basisi) {
				/* oVVhB */
				x_min = x_max = basisi[0][0];
				y_min = y_max = basisi[0][1];
				for(i = 0; i < n_basisi; i++) {
					if(basisi[i][0] < x_min) x_min = basisi[i][0];
					if(basisi[i][0] > x_max) x_max = basisi[i][0];
					if(basisi[i][1] < y_min) y_min = basisi[i][1];
					if(basisi[i][1] > y_max) y_max = basisi[i][1];
				}
				for(y = y_min; y <= y_max; y++) {
					for(x = x_min; x <= x_max; x++) {
						if(point_in_polygon_ex(x, y, basisi, n_basisi)) {
							gi->fill[DISP_X * y + x] |= 0x80;
						}
					}
					if(y & 1) { /* 2C/1t[ */
						field_disp();
						schedule();
					}
				}
				field_disp();
				for(j = 0; j < SEC(0.25); j++) schedule(); /* EFCg */

				/* }VŁB */
				for(i = 0, enemy = gi->mush; i < MAX_MUSH; i++, enemy++) {
					if(!enemy->stat) continue;
					switch(enemy->stat) { /* 肠Ȃ... */
					case STAT_MUSH_MOVE:
						x = enemy->x >> 8;
						y = enemy->y >> 8;
						if(point_in_polygon_ex(x, y, basisi, n_basisi)) {
							memset(enemy, 0, sizeof(ENEMY));
							gi->score += MUSH_PTS;
							field_disp(); /* tB[h\ */
							for(j = 0; j < SEC(0.25); j++) schedule(); /* EFCg */
						}
						break;
					}
				}

				/* VFA[ŁB */
				for(i = 0, enemy = gi->shear; i < MAX_SHEAR; i++, enemy++) {
					if(!enemy->stat) continue;
					switch(enemy->stat) { /* 肠Ȃ... */
					case STAT_SHEAR_MOVE:
						x = enemy->x >> 8;
						y = enemy->y >> 8;
						if(point_in_polygon_ex(x, y, basisi, n_basisi)) {
							memset(enemy, 0, sizeof(ENEMY));
							gi->score += SHEAR_PTS;
							field_disp(); /* tB[h\ */
							for(j = 0; j < SEC(0.25); j++) schedule(); /* EFCg */
						}
						break;
					}
				}

				/* zuXe[^XύXB */
				for(i = 0, enemy = gi->hobb; i < MAX_HOBB; i++, enemy++) {
					if(!enemy->stat) continue;
					switch(enemy->stat) { /* 肠Ȃ... */
					case STAT_HOBB_MOVE:
					case STAT_HOBB_CHASE_PRE:
					case STAT_HOBB_CHASE:
						x = enemy->x >> 8;
						y = enemy->y >> 8;
						if(point_in_polygon_ex(x, y, basisi, n_basisi)) {
							enemy->stat = STAT_HOBB_RETIRE;
							gi->score += HOBB_PTS;
						}
						break;
					}
				}

				/* rnhB */
				for(y = y_min; y <= y_max; y++) {
					for(x = x_min; x <= x_max; x++) {
						c = gi->fill[DISP_X * y + x];
						if(c & 0x80) {
							c = (c & ~0x80) + 1;
							if(c > 3) c = 3;
							gi->fill[DISP_X * y + x] = c;
						}
					}
				}

				/* q𒼐ɖ߂܂B */
				gi->himo[1] = gi->himo[gi->n_himo - 1];
				gi->n_himo = 2;

				/* NAB(}VSŁH) */
				for(i = 0, enemy = gi->mush; i < MAX_MUSH; i++, enemy++) {
					if(enemy->stat) break;
				}
				if(i == MAX_MUSH) goto SEASON_LOOP_EXIT;
			}

			/********** G **********/

			/* GړB */
			enemy_work();

			/* zuƃuu̓蔻B */
			p1 = gi->himo[0             ].p;
			p2 = gi->himo[gi->n_himo - 1].p;
			for(i = 0, enemy = gi->hobb; i < MAX_HOBB; i++, enemy++) {
				if(!enemy->stat) continue;
				switch(enemy->stat) { /* 蔻肪... */
				case STAT_HOBB_MOVE:
				case STAT_HOBB_CHASE_PRE:
				case STAT_HOBB_CHASE:
					x = enemy->x >> 8;
					y = enemy->y >> 8;
					if((abs(p1.x - x) < 5/*v*/ && abs(p1.y - y) < 5/*v*/) ||
					   (abs(p2.x - x) < 5/*v*/ && abs(p2.y - y) < 5/*v*/)) {
						gi->miss = 1;
						goto SEASON_LOOP_EXIT;
					}
					break;
				}
			}

			/* BR}hEXe[WNAB */
			if((joy & (PAD_A | PAD_B | PAD_START | PAD_SELECT)) == (PAD_A | PAD_B | PAD_START | PAD_SELECT)) goto SEASON_LOOP_EXIT;

			/* tB[h\B */
			field_disp();
		}
SEASON_LOOP_EXIT:
		if(gi->miss) {
			/* uuŉoB */
			for(gi->cnt = 0; gi->cnt < 4; gi->cnt++) {
				field_disp();
				for(i = 0; i < SEC(0.5); i++) schedule();
			}

			/* c@炵āA0ɂȂQ[I[o[B */
			gi->left--;
			if(gi->left == 0) break;
		}

		/* V[YNAȂÃV[YցB */
		if(!gi->miss) gi->season_no++;
	}

	/* GAMEOVER\ */
	gi->n_himo = 0;
	memset(gi->mush, 0, sizeof gi->mush);
	memset(gi->hobb, 0, sizeof gi->hobb);
	memset(gi->shear, 0, sizeof gi->shear);
	field_disp();
	pceFontSetType(0x80);
	pceFontSetTxColor(3);
	pceFontSetBkColor(-1);
	pceFontSetPos(FIELD_X + (FIELD_W - 5 * 9) / 2, FIELD_Y + (FIELD_H - 10) / 2);
	pceFontPutStr("GAME OVER");
	for(i = 0; i < SEC(5); i++) {
		schedule();
		if((i >= SEC(2)) && (joy & TRG_MASK)) break;
	}

	/* nCXRAXVB */
	if(gi->score > hiscore) hiscore = gi->score;
}

/****************************************************************************
 *	season_init
 ****************************************************************************/

void
season_init()
{
	int i, j, col, row, x, y, x_unit, y_unit;
	const unsigned char (*kp)[KUI_COLS];
	KUI* kui;
	ENEMY* enemy;

	/* ݂̃V[Yւ̃|C^i[܂B */
	gi->season = &seasons[gi->season_no <= MAX_SEASON_NO ?
			      gi->season_no :  MAX_SEASON_NO];

	/* NCB */
	kp = kui_ptn[KUI_PTN_NO];
	gi->n_kui = 0;
	kui = gi->kui;
	x_unit = FIELD_W /  KUI_COLS;      /* E}[W͏ */
	y_unit = FIELD_H / (KUI_ROWS + 1); /* ㉺}[W͑傫 */
	y = y_unit;
	for(row = 0; row < KUI_ROWS; row++) {
		x = x_unit / 2;
		for(col = 0; col < KUI_COLS; col++) {
			if(gi->n_kui < MAX_KUI && kp[row][col]) {
				kui->x = FIELD_X + x;
				kui->y = FIELD_Y + y;
				gi->n_kui++;
				kui++;
			}
			x += x_unit;
		}
		y += y_unit;
	}

	/* qB(擪Ɩ o ͊֌WȂ̂ŁAݒsvł) */
	gi->n_himo = 2;
	gi->himo[0].p.x = FIELD_X + FIELD_W * 3 / 7;
	gi->himo[0].p.y = FIELD_Y + FIELD_H / 2;
	gi->himo[1].p.x = FIELD_X + FIELD_W * 4 / 7;
	gi->himo[1].p.y = FIELD_Y + FIELD_H / 2;

	/* }VB */
	if(!gi->miss) memset(gi->mush, 0, sizeof gi->mush);
	i = 0;
	enemy = gi->mush;
	for(row = 0; row < 2; row++) {
		y = row == 0 ? FIELD_Y           + 16
			     : FIELD_Y + FIELD_H - 16;
		for(col = 0; col < 2; col++) {
			x = col == 0 ? FIELD_X           + 24
				     : FIELD_X + FIELD_W - 24;
			for(j = 0; j < 4; j++) {
				if(i < MAX_MUSH) {
					if(!gi->miss || enemy->stat) { /* X^[g͑O̎c肾g */
						enemy->stat = STAT_MUSH_MOVE;
						enemy->x = ( x      + RND(-6, 6)) << 8;
						enemy->y = ((y + 4) + RND(-4, 4)) << 8;
						enemy->dir = RND(0, 7);
					}
					enemy++;
					i++;
				}
			}
		}
	}

	/* zuB */
	i = 0;
	enemy = gi->hobb;
	for(row = 0; row < 2; row++) {
		y = row == 0 ? FIELD_Y           + 16
			     : FIELD_Y + FIELD_H - 16;
		for(col = 0; col < 2; col++) {
			x = col == 0 ? FIELD_X           + 24
				     : FIELD_X + FIELD_W - 24;
			if(i < MAX_HOBB) {
				enemy->stat = STAT_HOBB_MOVE;
				enemy->x =  x      << 8;
				enemy->y = (y - 4) << 8;
				enemy->dir = RND(0, 7);
				enemy++;
				i++;
			}
		}
	}

	/* VFA[B */
	memset(gi->shear, 0, sizeof gi->shear);

	/* X^[gȂAh菉B */
	if(gi->miss) memset(gi->fill, 0, sizeof gi->fill);

	/* ~XEJE^NAB */
	gi->miss = 0;
	gi->cnt = 0;

	/* zupϐNAB */
	gi->hobb_stat = 0;
	gi->hobb_cnt = 0;

	/* VFA[pϐNAB */
	gi->shear_cnt = 0;
}

/****************************************************************************
 *	field_disp
 ****************************************************************************/

void
field_disp()
{
	int i, x, y, chr, prm;
	unsigned char c, *src, *dst;
	KUI* kui;
	HIMO* himo;
	ENEMY* enemy;

	/* wi\B */
	draw_object(&bg, 0, 0, 0, 128, DISP_X, DISP_Y, DRW_NOMAL);

	/* h\B */
	dst = &vbuff   [DISP_X * FIELD_Y + FIELD_X];
	src = &gi->fill[DISP_X * FIELD_Y + FIELD_X];
	for(y = 0; y < FIELD_H; y++) {
		for(x = 0; x < FIELD_W; x++) {
			c = *src++;
			switch(c) {
			case  0:                             break;
			case  1: *dst = (x ^ y) & 1 ? 1 : 0; break;
			case  2: *dst =               1    ; break;
			case  3: *dst = (x ^ y) & 1 ? 2 : 1; break;
			default: *dst =               2    ; break;
			}
			dst++;
		}
		dst += DISP_X - FIELD_W;
		src += DISP_X - FIELD_W;
	}

	/* q\B */
	for(i = 0, himo = gi->himo; i < gi->n_himo - 1; i++, himo++) {
		render_line(render, himo[0].p.x, himo[0].p.y,
				    himo[1].p.x, himo[1].p.y, 3);
	}

	/* NC\B */
	for(i = 0, kui = gi->kui; i < gi->n_kui; i++, kui++) {
		chr_disp(kui->x, kui->y, CHR_KUI, DRW_NOMAL);
	}

	/* uu\B */
	if(gi->n_himo >= 2) {
		himo = &gi->himo[0];
		chr = CHR_LIBB;
		if(gi->miss) chr += gi->cnt; /* ~Xp^[ */
		chr_disp(himo->p.x, himo->p.y, chr, DRW_NOMAL);
		himo = &gi->himo[gi->n_himo - 1];
		chr = CHR_RABB;
		if(gi->miss) chr += gi->cnt; /* ~Xp^[ */
		chr_disp(himo->p.x, himo->p.y, chr, DRW_NOMAL);
	}

	/* }V\B */
	for(i = 0, enemy = gi->mush; i < MAX_MUSH; i++, enemy++) {
		if(!enemy->stat) continue;
		x = enemy->x >> 8;
		y = enemy->y >> 8;
		switch(enemy->stat) {
		case STAT_MUSH_MOVE:
			chr = CHR_MUSH;
			chr += enemy->anm / SEC(0.25) & 1;
			prm = enemy->dir < 4 ? DRW_NOMAL : DRW_REVX;
			chr_disp(x, y, chr, prm);
			break;
		}
	}

	/* zu\B */
	for(i = 0, enemy = gi->hobb; i < MAX_HOBB; i++, enemy++) {
		if(!enemy->stat) continue;
		x = enemy->x >> 8;
		y = enemy->y >> 8;
		switch(enemy->stat) {
		case STAT_HOBB_MOVE:
		case STAT_HOBB_WAIT:
		case STAT_HOBB_APPEAR:
			chr = CHR_HOBB + 0;
			chr += enemy->anm / SEC(0.25) & 1;
			prm = enemy->dir < 4 ? DRW_NOMAL : DRW_REVX;
			chr_disp(x, y, chr, prm);
			break;
		case STAT_HOBB_CHASE_PRE:
		case STAT_HOBB_CHASE:
			chr = CHR_HOBB + 2;
			chr += enemy->anm / SEC(0.25) & 1;
			prm = enemy->dir < 4 ? DRW_NOMAL : DRW_REVX;
			chr_disp(x, y, chr, prm);
			break;
		case STAT_HOBB_RETIRE:
			chr = CHR_HOBB + 0;
			prm = DRW_REVY;
			chr_disp(x, y, chr, prm);
			break;
		}
	}

	/* VFA[\B */
	for(i = 0, enemy = gi->shear; i < MAX_SHEAR; i++, enemy++) {
		if(!enemy->stat) continue;
		x = enemy->x >> 8;
		y = enemy->y >> 8;
		switch(enemy->stat) {
		case STAT_SHEAR_MOVE_PRE:
			if(enemy->anm % SEC(0.3) >= SEC(0.2)) break;
			/* FALL THRU */ 
		case STAT_SHEAR_MOVE:
			switch(enemy->dir) {
			case 0:
				chr = CHR_SHEAR + 4;
				prm = DRW_REVY;
				break;
			case 1:
				chr = CHR_SHEAR + 2;
				prm = DRW_REVY;
				break;
			case 2:
				chr = CHR_SHEAR + 0;
				prm = DRW_NOMAL;
				break;
			case 3:
				chr = CHR_SHEAR + 2;
				prm = DRW_NOMAL;
				break;
			case 4:
				chr = CHR_SHEAR + 4;
				prm = DRW_NOMAL;
				break;
			case 5:
				chr = CHR_SHEAR + 2;
				prm = DRW_REVX;
				break;
			case 6:
				chr = CHR_SHEAR + 0;
				prm = DRW_REVX;
				break;
			default: /*7*/
				chr = CHR_SHEAR + 2;
				prm = DRW_REVX | DRW_REVY;
				break;
			}
			chr += enemy->anm / SEC(0.25) & 1;
			chr_disp(x, y, chr, prm);
			break;
		}
	}

	/* XRAEV[YEc@\B */
	pceFontSetType(0x82);
	pceFontSetTxColor(3);
	pceFontSetBkColor(-1);
	pceFontSetPos(0, 0);
	pceFontPrintf("%7d", gi->score < 9999999 ? gi->score : 9999999);
	pceFontSetPos(DISP_X - 4 * 8 + 1, 0);
	pceFontPrintf("SEASON%2d", gi->season_no < 99 ? gi->season_no : 99);
	if(gi->left > 1) {
		pceFontSetPos(DISP_X - 4 * 5 + 1, 6);
		pceFontPrintf("%dLEFT", gi->left - 1);
	}
}

/****************************************************************************
 *	enemy_work
 ****************************************************************************/

static int
enemy_move(ENEMY* enemy, int x_min, int y_min, int x_max, int y_max, int speed)
{
	int i, x, y, vx, vy, px, py, cross;
	HIMO* himo;
	POINT p1, p2, p3, p4;

	/* ړ̍WvZAtB[h[Ŕ]B */
	x = enemy->x;
	y = enemy->y;
	vx = v_dir[enemy->dir][0];
	vy = v_dir[enemy->dir][1];
	if(vx < 0) {
		x -= speed;
		if(x < x_min) {
			x = x_min;
			enemy->dir = (0 - enemy->dir) & 7;
		}
	} else if(vx > 0) {
		x += speed;
		if(x > x_max) {
			x = x_max;
			enemy->dir = (0 - enemy->dir) & 7;
		}
	}
	if(vy < 0) {
		y -= speed;
		if(y < y_min) {
			y = y_min;
			enemy->dir = (4 - enemy->dir) & 7;
		}
	} else if(vy > 0) {
		y += speed;
		if(y > y_max) {
			y = y_max;
			enemy->dir = (4 - enemy->dir) & 7;
		}
	}
	/* ړOՂƃq̌B */
	p1.x = enemy->x >> 8;
	p1.y = enemy->y >> 8;
	p2.x = x >> 8;
	p2.y = y >> 8;
	cross = 0;
	for(i = 0, himo = gi->himo; i < gi->n_himo - 1; i++, himo++) {
		p3 = himo[0].p;
		p4 = himo[1].p;
		if((cross_point_32(p1.x, p1.y, p2.x, p2.y, p3.x, p3.y, p4.x, p4.y, NULL, NULL)) ||
		   (ortho_point_32(p2.x, p2.y, p3.x, p3.y, p4.x, p4.y, &px, &py) && px == p2.x && py == p2.y)) { /* ȂƃqŌł܂邱Ƃ */
			cross = 1;
			break;
		}
	}
	if(cross) { /* cړTRY */
		p1.x = enemy->x >> 8;
		p1.y = enemy->y >> 8;
		p2.x = enemy->x >> 8;
		p2.y = y >> 8;
		cross = 0;
		for(i = 0, himo = gi->himo; i < gi->n_himo - 1; i++, himo++) {
			p3 = himo[0].p;
			p4 = himo[1].p;
			if((cross_point_32(p1.x, p1.y, p2.x, p2.y, p3.x, p3.y, p4.x, p4.y, NULL, NULL)) ||
			   (ortho_point_32(p2.x, p2.y, p3.x, p3.y, p4.x, p4.y, &px, &py) && px == p2.x && py == p2.y)) { /* ȂƃqŌł܂邱Ƃ */
				cross = 1;
				break;
			}
		}
		if(!cross) x = enemy->x;
	}
	if(cross) { /* ړTRY */
		p1.x = enemy->x >> 8;
		p1.y = enemy->y >> 8;
		p2.x = x >> 8;
		p2.y = enemy->y >> 8;
		cross = 0;
		for(i = 0, himo = gi->himo; i < gi->n_himo - 1; i++, himo++) {
			p3 = himo[0].p;
			p4 = himo[1].p;
			if((cross_point_32(p1.x, p1.y, p2.x, p2.y, p3.x, p3.y, p4.x, p4.y, NULL, NULL)) ||
			   (ortho_point_32(p2.x, p2.y, p3.x, p3.y, p4.x, p4.y, &px, &py) && px == p2.x && py == p2.y)) { /* ȂƃqŌł܂邱Ƃ */
				cross = 1;
				break;
			}
		}
		if(!cross) y = enemy->y;
	}
	/* ĂȂΈړB */
	if(!cross) {
		enemy->x = x;
		enemy->y = y;
	}

	return cross;
}

void
enemy_work()
{
	int i, j, x, y, vx, vy, px, py;
	ENEMY* enemy;
	HIMO* himo;
	POINT p1, p2, p3, p4;

	/* }VړB */
	for(i = 0, enemy = gi->mush; i < MAX_MUSH; i++, enemy++) {
		if(!enemy->stat) continue;
		switch(enemy->stat) {
		case STAT_MUSH_MOVE:
			if(enemy_move(enemy, FIELD_X << 8, FIELD_Y << 8, (FIELD_X + FIELD_W - 1) << 8, (FIELD_Y + FIELD_H - 1) << 8, MUSH_MOVE_SPD) ||
			   ++enemy->cnt >= MUSH_MOVE_CNT) {
				enemy->dir = (enemy->dir + RND(-2, 2)) & 7;
				enemy->cnt = 0;
			}
			enemy->anm++;
			break;
		}
	}

	/* zuԕύXB */
	switch(gi->hobb_stat) {
	case 0: /* ǐՃC^[o */
		gi->hobb_cnt++;
		if(gi->hobb_cnt >= HOBB_CHASE_ITV) {
			for(i = 0, enemy = gi->hobb; i < MAX_HOBB; i++, enemy++) {
				if(!enemy->stat) continue;
				if(enemy->stat == STAT_HOBB_MOVE) enemy->stat = STAT_HOBB_CHASE_PRE;
			}
			gi->hobb_stat = 1;
			gi->hobb_cnt = 0;
		}
		break;
	case 1: /* ǐՑO */
		gi->hobb_cnt++;
		if(gi->hobb_cnt >= HOBB_CHASE_PRE) {
			for(i = 0, enemy = gi->hobb; i < MAX_HOBB; i++, enemy++) {
				if(!enemy->stat) continue;
				if(enemy->stat == STAT_HOBB_CHASE_PRE) enemy->stat = STAT_HOBB_CHASE;
			}
			gi->hobb_stat = 2;
			gi->hobb_cnt = 0;
		}
		break;
	case 2: /* ǐՒ */
		gi->hobb_cnt++;
		if(gi->hobb_cnt >= HOBB_CHASE_CNT) {
			for(i = 0, enemy = gi->hobb; i < MAX_HOBB; i++, enemy++) {
				if(!enemy->stat) continue;
				if(enemy->stat == STAT_HOBB_CHASE) enemy->stat = STAT_HOBB_MOVE;
			}
			gi->hobb_stat = 0;
			gi->hobb_cnt = 0;
		}
		break;
	}

	/* zuړB */
	for(i = 0, enemy = gi->hobb; i < MAX_HOBB; i++, enemy++) {
		if(!enemy->stat) continue;
		switch(enemy->stat) {
		case STAT_HOBB_MOVE:
			if(enemy_move(enemy, FIELD_X << 8, FIELD_Y << 8, (FIELD_X + FIELD_W - 1) << 8, (FIELD_Y + FIELD_H - 1) << 8, HOBB_MOVE_SPD) ||
			   ++enemy->cnt >= HOBB_MOVE_CNT) {
				enemy->dir = (enemy->dir + RND(-2, 2)) & 7;
				enemy->cnt = 0;
			}
			enemy->anm++;
			break;
		case STAT_HOBB_CHASE_PRE:
		case STAT_HOBB_CHASE:
			p1 = gi->himo[gi->n_himo - 1].p;
			x = enemy->x >> 8;
			y = enemy->y >> 8;
			vx = p1.x - x;
			vy = p1.y - y;
			if(vy < 0) {
				if(vx < 0) {
					enemy->dir = 7;
				} else if(vx == 0) {
					enemy->dir = 0;
				} else {
					enemy->dir = 1;
				}
			} else if(vy == 0) {
				if(vx < 0) {
					enemy->dir = 6;
				} else if(vx == 0) {
					enemy->dir = 0;
				} else {
					enemy->dir = 2;
				}
			} else {
				if(vx < 0) {
					enemy->dir = 5;
				} else if(vx == 0) {
					enemy->dir = 4;
				} else {
					enemy->dir = 3;
				}
			}
			if(enemy->stat == STAT_HOBB_CHASE) {
				enemy_move(enemy, FIELD_X << 8, FIELD_Y << 8, (FIELD_X + FIELD_W - 1) << 8, (FIELD_Y + FIELD_H - 1) << 8, HOBB_CHASE_SPD);
			}
			enemy->anm++;
			break;
		case STAT_HOBB_RETIRE:
			p1.x = HOME_X + HOME_W * (i + 1) / (MAX_HOBB + 1);
			p1.y = HOME_Y + HOME_H / 2;
			x = enemy->x >> 8;
			y = enemy->y >> 8;
			if(x < p1.x) {
				x++;
			} else if(x > p1.x) {
				x--;
			}
			if(y < p1.y) {
				y++;
			} else if(y > p1.y) {
				y--;
			}
			enemy->x = x << 8;
			enemy->y = y << 8;
			enemy->anm++;
			if(x == p1.x && y == p1.y) {
				enemy->stat = STAT_HOBB_WAIT;
				enemy->cnt = 0;
			}
			break;
		case STAT_HOBB_WAIT:
			enemy_move(enemy, HOME_X << 8, HOME_Y << 8, (HOME_X + HOME_W - 1) << 8, (HOME_Y + HOME_H - 1) << 8, MUSH_MOVE_SPD);
			enemy->cnt++;
			if(enemy->cnt % HOBB_MOVE_CNT == 0) enemy->dir = (enemy->dir + RND(-2, 2)) & 7;
			enemy->anm++;
			if(enemy->cnt >= HOBB_WAIT_CNT) {
				enemy->stat = STAT_HOBB_APPEAR;
				enemy->cnt = 0;
			}
			break;
		case STAT_HOBB_APPEAR:
			if(enemy->y < FIELD_Y << 8) enemy->y += MUSH_MOVE_SPD;
			enemy->anm++;
			if(enemy->y >= FIELD_Y << 8) {
				enemy->stat = STAT_HOBB_MOVE;
				enemy->cnt = 0;
			}
			break;
		}
	}

	/* VFA[oB */
	for(i = 0, enemy = gi->shear; i < MAX_SHEAR; i++, enemy++) {
		if(!enemy->stat) break;
	}
	if(i < MAX_SHEAR) { /* 󂫂... */
		gi->shear_cnt++;
		if(gi->shear_cnt >= SHEAR_GEN_ITV) {
			enemy->stat = STAT_SHEAR_MOVE_PRE;
			enemy->cnt = 0;
			switch(RND(0, 3)) {
			case 0: /* o */
				enemy->x = FIELD_X << 8;
				enemy->y = RND(FIELD_Y + 16, FIELD_Y + FIELD_H - 16) << 8;
				enemy->dir = RND(1, 3);
				break;
			case 1: /* Eo */
				enemy->x = (FIELD_X + FIELD_W - 1) << 8;
				enemy->y = RND(FIELD_Y + 16, FIELD_Y + FIELD_H - 16) << 8;
				enemy->dir = RND(5, 7);
				break;
			case 2: /* ォo */
				enemy->x = RND(FIELD_X + 16, FIELD_X + FIELD_W - 16) << 8;
				enemy->y = FIELD_Y << 8;
				enemy->dir = RND(3, 5);
				break;
			case 3: /* o */
				enemy->x = RND(FIELD_X + 16, FIELD_X + FIELD_W - 16) << 8;
				enemy->y = (FIELD_Y + FIELD_H - 1) << 8;
				enemy->dir = RND(7, 9) & 7;
				break;
			}
			/* oC^[oZbgB */
			gi->shear_cnt = 0;
		}
	}

	/* VFA[ړB */
	for(i = 0, enemy = gi->shear; i < MAX_SHEAR; i++, enemy++) {
		if(!enemy->stat) continue;
		switch(enemy->stat) {
		case STAT_SHEAR_MOVE_PRE:
			enemy->anm++;
			enemy->cnt++;
			if(enemy->cnt >= SHEAR_MOVE_PRE) {
				enemy->stat = STAT_SHEAR_MOVE;
				enemy->cnt = 0;
			}
			break;
		case STAT_SHEAR_MOVE:
			x = enemy->x;
			y = enemy->y;
			vx = v_dir[enemy->dir][0];
			vy = v_dir[enemy->dir][1];
			if(vx < 0) {
				x -= SHEAR_MOVE_SPD;
				if(x < FIELD_X << 8) {
					memset(enemy, 0, sizeof(ENEMY));
					break;
				}
			} else if(vx > 0) {
				x += SHEAR_MOVE_SPD;
				if(x > (FIELD_X + FIELD_W - 1) << 8) {
					memset(enemy, 0, sizeof(ENEMY));
					break;
				}
			}
			if(vy < 0) {
				y -= SHEAR_MOVE_SPD;
				if(y < FIELD_Y << 8) {
					memset(enemy, 0, sizeof(ENEMY));
					break;
				}
			} else if(vy > 0) {
				y += SHEAR_MOVE_SPD;
				if(y > (FIELD_Y + FIELD_H - 1) << 8) {
					memset(enemy, 0, sizeof(ENEMY));
					break;
				}
			}
			/* q؂H */
			p1.x = enemy->x >> 8;
			p1.y = enemy->y >> 8;
			p2.x = x >> 8;
			p2.y = y >> 8;
			for(j = 0, himo = gi->himo; j < gi->n_himo - 1; j++, himo++) {
				p3 = himo[0].p;
				p4 = himo[1].p;
				if((cross_point_32(p1.x, p1.y, p2.x, p2.y, p3.x, p3.y, p4.x, p4.y, NULL, NULL)) ||
				   (ortho_point_32(p2.x, p2.y, p3.x, p3.y, p4.x, p4.y, &px, &py) && px == p2.x && py == p2.y)) {
					break;
				}
			}
			if(j < gi->n_himo - 1) {
				gi->himo[1] = gi->himo[gi->n_himo - 1];
				gi->n_himo = 2;
			}
			/* Vʒui[B */
			enemy->x = x;
			enemy->y = y;
			enemy->anm++;
			break;
		}
	}
}
